--- linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_guts.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_guts.c	2014-07-29 17:28:38.819972000 +0800
@@ -2475,200 +2552,36 @@
 
 	dev->gc_disable = 1;
 
+	yaffs_summary_gc(dev, block);
+
 	if (is_checkpt_block || !yaffs_still_some_chunks(dev, block)) {
 		yaffs_trace(YAFFS_TRACE_TRACING,
 			"Collecting block %d that has no chunks in use",
-		   	block);
-		yaffs_block_became_dirty(dev, block);
-	} else {
-
-		u8 *buffer = yaffs_get_temp_buffer(dev, __LINE__);
-
-		yaffs_verify_blk(dev, bi, block);
-
-		max_copies = (whole_block) ? dev->param.chunks_per_block : 5;
-		old_chunk = block * dev->param.chunks_per_block + dev->gc_chunk;
-
-		for ( /* init already done */ ;
-		     ret_val == YAFFS_OK &&
-		     dev->gc_chunk < dev->param.chunks_per_block &&
-		     (bi->block_state == YAFFS_BLOCK_STATE_COLLECTING) &&
-		     max_copies > 0; dev->gc_chunk++, old_chunk++) {
-			if (yaffs_check_chunk_bit(dev, block, dev->gc_chunk)) {
-
-				/* This page is in use and might need to be copied off */
-
-				max_copies--;
-
-				mark_flash = 1;
-
-				yaffs_init_tags(&tags);
-
-				yaffs_rd_chunk_tags_nand(dev, old_chunk,
-							 buffer, &tags);
-
-				object = yaffs_find_by_number(dev, tags.obj_id);
-
-				yaffs_trace(YAFFS_TRACE_GC_DETAIL,
-					"Collecting chunk in block %d, %d %d %d ",
-					dev->gc_chunk, tags.obj_id,
-					tags.chunk_id, tags.n_bytes);
-
-				if (object && !yaffs_skip_verification(dev)) {
-					if (tags.chunk_id == 0)
-						matching_chunk =
-						    object->hdr_chunk;
-					else if (object->soft_del)
-						matching_chunk = old_chunk;	/* Defeat the test */
-					else
-						matching_chunk =
-						    yaffs_find_chunk_in_file
-						    (object, tags.chunk_id,
-						     NULL);
-
-					if (old_chunk != matching_chunk)
-						yaffs_trace(YAFFS_TRACE_ERROR,
-							"gc: page in gc mismatch: %d %d %d %d",
-							old_chunk,
-							matching_chunk,
-							tags.obj_id,
-						   	tags.chunk_id);
-
-				}
-
-				if (!object) {
-					yaffs_trace(YAFFS_TRACE_ERROR,
-						"page %d in gc has no object: %d %d %d ",
-						old_chunk,
-						tags.obj_id, tags.chunk_id,
-						tags.n_bytes);
-				}
-
-				if (object &&
-				    object->deleted &&
-				    object->soft_del && tags.chunk_id != 0) {
-					/* Data chunk in a soft deleted file, throw it away
-					 * It's a soft deleted data chunk,
-					 * No need to copy this, just forget about it and
-					 * fix up the object.
-					 */
-
-					/* Free chunks already includes softdeleted chunks.
-					 * How ever this chunk is going to soon be really deleted
-					 * which will increment free chunks.
-					 * We have to decrement free chunks so this works out properly.
-					 */
-					dev->n_free_chunks--;
-					bi->soft_del_pages--;
-
-					object->n_data_chunks--;
-
-					if (object->n_data_chunks <= 0) {
-						/* remeber to clean up the object */
-						dev->gc_cleanup_list[dev->
-								     n_clean_ups]
-						    = tags.obj_id;
-						dev->n_clean_ups++;
-					}
-					mark_flash = 0;
-				} else if (0) {
-					/* Todo object && object->deleted && object->n_data_chunks == 0 */
-					/* Deleted object header with no data chunks.
-					 * Can be discarded and the file deleted.
-					 */
-					object->hdr_chunk = 0;
-					yaffs_free_tnode(object->my_dev,
-							 object->
-							 variant.file_variant.
-							 top);
-					object->variant.file_variant.top = NULL;
-					yaffs_generic_obj_del(object);
-
-				} else if (object) {
-					/* It's either a data chunk in a live file or
-					 * an ObjectHeader, so we're interested in it.
-					 * NB Need to keep the ObjectHeaders of deleted files
-					 * until the whole file has been deleted off
-					 */
-					tags.serial_number++;
+			block);
+		yaffs_block_became_dirty(dev, block);
+	} else {
 
-					dev->n_gc_copies++;
+		u8 *buffer = yaffs_get_temp_buffer(dev);
 
-					if (tags.chunk_id == 0) {
-						/* It is an object Id,
-						 * We need to nuke the shrinkheader flags first
-						 * Also need to clean up shadowing.
-						 * We no longer want the shrink_header flag since its work is done
-						 * and if it is left in place it will mess up scanning.
-						 */
-
-						struct yaffs_obj_hdr *oh;
-						oh = (struct yaffs_obj_hdr *)
-						    buffer;
-
-						oh->is_shrink = 0;
-						tags.extra_is_shrink = 0;
-
-						oh->shadows_obj = 0;
-						oh->inband_shadowed_obj_id = 0;
-						tags.extra_shadows = 0;
-
-						/* Update file size */
-						if (object->variant_type ==
-						    YAFFS_OBJECT_TYPE_FILE) {
-							oh->file_size =
-							    object->variant.
-							    file_variant.
-							    file_size;
-							tags.extra_length =
-							    oh->file_size;
-						}
-
-						yaffs_verify_oh(object, oh,
-								&tags, 1);
-						new_chunk =
-						    yaffs_write_new_chunk(dev,
-									  (u8 *)
-									  oh,
-									  &tags,
-									  1);
-					} else {
-						new_chunk =
-						    yaffs_write_new_chunk(dev,
-									  buffer,
-									  &tags,
-									  1);
-                                        }
-
-					if (new_chunk < 0) {
-						ret_val = YAFFS_FAIL;
-					} else {
-
-						/* Ok, now fix up the Tnodes etc. */
-
-						if (tags.chunk_id == 0) {
-							/* It's a header */
-							object->hdr_chunk =
-							    new_chunk;
-							object->serial =
-							    tags.serial_number;
-						} else {
-							/* It's a data chunk */
-							int ok;
-							ok = yaffs_put_chunk_in_file(object, tags.chunk_id, new_chunk, 0);
-						}
-					}
-				}
+		yaffs_verify_blk(dev, bi, block);
 
-				if (ret_val == YAFFS_OK)
-					yaffs_chunk_del(dev, old_chunk,
-							mark_flash, __LINE__);
+		max_copies = (whole_block) ? dev->param.chunks_per_block : 5;
+		old_chunk = block * dev->param.chunks_per_block + dev->gc_chunk;
 
+		for (/* init already done */ ;
+		     ret_val == YAFFS_OK &&
+		     dev->gc_chunk < dev->param.chunks_per_block &&
+		     (bi->block_state == YAFFS_BLOCK_STATE_COLLECTING) &&
+		     max_copies > 0;
+		     dev->gc_chunk++, old_chunk++) {
+			if (yaffs_check_chunk_bit(dev, block, dev->gc_chunk)) {
+				/* Page is in use and might need to be copied */
+				max_copies--;
+				ret_val = yaffs_gc_process_chunk(dev, bi,
+							old_chunk, buffer);
 			}
 		}
-
-		yaffs_release_temp_buffer(dev, buffer, __LINE__);
-
+		yaffs_release_temp_buffer(dev, buffer);
 	}
 
 	yaffs_verify_collected_blk(dev, bi, block);
@@ -2684,12 +2597,11 @@
 		/* Do any required cleanups */
 		for (i = 0; i < dev->n_clean_ups; i++) {
 			/* Time to delete the file too */
-			object =
+			struct yaffs_obj *object =
 			    yaffs_find_by_number(dev, dev->gc_cleanup_list[i]);
 			if (object) {
 				yaffs_free_tnode(dev,
-						 object->variant.
-						 file_variant.top);
+					  object->variant.file_variant.top);
 				object->variant.file_variant.top = NULL;
 				yaffs_trace(YAFFS_TRACE_GC,
 					"yaffs: About to finally delete object %d",
@@ -2699,7 +2611,6 @@
 			}
 
 		}
-
 		chunks_after = yaffs_get_erased_chunks(dev);
 		if (chunks_before >= chunks_after)
 			yaffs_trace(YAFFS_TRACE_GC,
@@ -2716,7 +2627,7 @@
 }
 
 /*
- * FindBlockForgarbageCollection is used to select the dirtiest block (or close enough)
+ * find_gc_block() selects the dirtiest block (or close enough)
  * for garbage collection.
  */
 
@@ -2751,8 +2662,8 @@
 
 		/*
 		 * If there is a prioritised block and none was selected then
-		 * this happened because there is at least one old dirty block gumming
-		 * up the works. Let's gc the oldest dirty block.
+		 * this happened because there is at least one old dirty block
+		 * gumming up the works. Let's gc the oldest dirty block.
 		 */
 
 		if (prioritised_exist &&
@@ -2763,9 +2674,9 @@
 			dev->has_pending_prioritised_gc = 0;
 	}
 
-	/* If we're doing aggressive GC then we are happy to take a less-dirty block, and
-	 * search harder.
-	 * else (we're doing a leasurely gc), then we only bother to do this if the
+	/* If we're doing aggressive GC then we are happy to take a less-dirty
+	 * block, and search harder.
+	 * else (leasurely gc), then we only bother to do this if the
 	 * block has only a few pages in use.
 	 */
 
@@ -2801,7 +2712,8 @@
 		for (i = 0;
 		     i < iterations &&
 		     (dev->gc_dirtiest < 1 ||
-		      dev->gc_pages_in_use > YAFFS_GC_GOOD_ENOUGH); i++) {
+		      dev->gc_pages_in_use > YAFFS_GC_GOOD_ENOUGH);
+		     i++) {
 			dev->gc_block_finder++;
 			if (dev->gc_block_finder < dev->internal_start_block ||
 			    dev->gc_block_finder > dev->internal_end_block)
@@ -2814,9 +2726,9 @@
 
 			if (bi->block_state == YAFFS_BLOCK_STATE_FULL &&
 			    pages_used < dev->param.chunks_per_block &&
-			    (dev->gc_dirtiest < 1
-			     || pages_used < dev->gc_pages_in_use)
-			    && yaffs_block_ok_for_gc(dev, bi)) {
+			    (dev->gc_dirtiest < 1 ||
+			     pages_used < dev->gc_pages_in_use) &&
+			    yaffs_block_ok_for_gc(dev, bi)) {
 				dev->gc_dirtiest = dev->gc_block_finder;
 				dev->gc_pages_in_use = pages_used;
 			}
@@ -2827,7 +2739,7 @@
 	}
 
 	/*
-	 * If nothing has been selected for a while, try selecting the oldest dirty
+	 * If nothing has been selected for a while, try the oldest dirty
 	 * because that's gumming up the works.
 	 */
 
@@ -2843,7 +2755,7 @@
 			    bi->pages_in_use - bi->soft_del_pages;
 		} else {
 			dev->gc_not_done = 0;
-                }
+		}
 	}
 
 	if (selected) {
@@ -2878,7 +2790,7 @@
  * If we're very low on erased blocks then we do aggressive garbage collection
  * otherwise we do "leasurely" garbage collection.
  * Aggressive gc looks further (whole array) and will accept less dirty blocks.
- * Passive gc only inspects smaller areas and will only accept more dirty blocks.
+ * Passive gc only inspects smaller areas and only accepts more dirty blocks.
  *
  * The idea is to help clear out space in a more spread-out manner.
  * Dunno if it really does anything useful.
@@ -2895,13 +2807,12 @@
 	if (dev->param.gc_control && (dev->param.gc_control(dev) & 1) == 0)
 		return YAFFS_OK;
 
-	if (dev->gc_disable) {
+	if (dev->gc_disable)
 		/* Bail out so we don't get recursive gc */
 		return YAFFS_OK;
-	}
 
 	/* This loop should pass the first time.
-	 * We'll only see looping here if the collection does not increase space.
+	 * Only loops here if the collection does not increase space.
 	 */
 
 	do {
@@ -2935,7 +2846,8 @@
 
 		dev->gc_skip = 5;
 
-		/* If we don't already have a block being gc'd then see if we should start another */
+		/* If we don't already have a block being gc'd then see if we
+		 * should start another */
 
 		if (dev->gc_block < 1 && !aggressive) {
 			dev->gc_block = yaffs2_find_refresh_block(dev);
@@ -2961,8 +2873,8 @@
 			gc_ok = yaffs_gc_block(dev, dev->gc_block, aggressive);
 		}
 
-		if (dev->n_erased_blocks < (dev->param.n_reserved_blocks)
-		    && dev->gc_block > 0) {
+		if (dev->n_erased_blocks < (dev->param.n_reserved_blocks) &&
+		    dev->gc_block > 0) {
 			yaffs_trace(YAFFS_TRACE_GC,
 				"yaffs: GC !!!no reclaim!!! n_erased_blocks %d after try %d block %d",
 				dev->n_erased_blocks, max_tries,
@@ -3039,10 +2951,8 @@
 	if (!dev->param.is_yaffs2 && mark_flash &&
 	    bi->block_state != YAFFS_BLOCK_STATE_COLLECTING) {
 
-		yaffs_init_tags(&tags);
-
+		memset(&tags, 0, sizeof(tags));
 		tags.is_deleted = 1;
-
 		yaffs_wr_chunk_tags_nand(dev, chunk_id, NULL, &tags);
 		yaffs_handle_chunk_update(dev, chunk_id, &tags);
 	} else {
@@ -3054,27 +2964,23 @@
 	 */
 	if (bi->block_state == YAFFS_BLOCK_STATE_ALLOCATING ||
 	    bi->block_state == YAFFS_BLOCK_STATE_FULL ||
-	    bi->block_state == YAFFS_BLOCK_STATE_NEEDS_SCANNING ||
+	    bi->block_state == YAFFS_BLOCK_STATE_NEEDS_SCAN ||
 	    bi->block_state == YAFFS_BLOCK_STATE_COLLECTING) {
 		dev->n_free_chunks++;
-
 		yaffs_clear_chunk_bit(dev, block, page);
-
 		bi->pages_in_use--;
 
 		if (bi->pages_in_use == 0 &&
 		    !bi->has_shrink_hdr &&
 		    bi->block_state != YAFFS_BLOCK_STATE_ALLOCATING &&
-		    bi->block_state != YAFFS_BLOCK_STATE_NEEDS_SCANNING) {
+		    bi->block_state != YAFFS_BLOCK_STATE_NEEDS_SCAN) {
 			yaffs_block_became_dirty(dev, block);
 		}
-
 	}
-
 }
 
 static int yaffs_wr_data_obj(struct yaffs_obj *in, int inode_chunk,
-			     const u8 * buffer, int n_bytes, int use_reserve)
+			     const u8 *buffer, int n_bytes, int use_reserve)
 {
 	/* Find old chunk Need to do this to get serial number
 	 * Write new one and patch into tree.
@@ -3083,10 +2989,8 @@
 
 	int prev_chunk_id;
 	struct yaffs_ext_tags prev_tags;
-
 	int new_chunk_id;
 	struct yaffs_ext_tags new_tags;
-
 	struct yaffs_dev *dev = in->my_dev;
 
 	yaffs_check_gc(dev, 0);
@@ -3101,7 +3005,7 @@
 		return 0;
 
 	/* Set up new tags */
-	yaffs_init_tags(&new_tags);
+	memset(&new_tags, 0, sizeof(new_tags));
 
 	new_tags.chunk_id = inode_chunk;
 	new_tags.obj_id = in->obj_id;
@@ -3113,7 +3017,7 @@
 		yaffs_trace(YAFFS_TRACE_ERROR,
 		  "Writing %d bytes to chunk!!!!!!!!!",
 		   n_bytes);
-		YBUG();
+		BUG();
 	}
 
 	new_chunk_id =
@@ -3134,11 +3038,10 @@
 
 
 static int yaffs_do_xattrib_mod(struct yaffs_obj *obj, int set,
-				const YCHAR * name, const void *value, int size,
+				const YCHAR *name, const void *value, int size,
 				int flags)
 {
 	struct yaffs_xattr_mod xmod;
-
 	int result;
 
 	xmod.set = set;
@@ -3163,7 +3066,6 @@
 	int x_offs = sizeof(struct yaffs_obj_hdr);
 	struct yaffs_dev *dev = obj->my_dev;
 	int x_size = dev->data_bytes_per_chunk - sizeof(struct yaffs_obj_hdr);
-
 	char *x_buffer = buffer + x_offs;
 
 	if (xmod->set)
@@ -3175,13 +3077,12 @@
 
 	obj->has_xattr = nval_hasvalues(x_buffer, x_size);
 	obj->xattr_known = 1;
-
 	xmod->result = retval;
 
 	return retval;
 }
 
-static int yaffs_do_xattrib_fetch(struct yaffs_obj *obj, const YCHAR * name,
+static int yaffs_do_xattrib_fetch(struct yaffs_obj *obj, const YCHAR *name,
 				  void *value, int size)
 {
 	char *buffer = NULL;
@@ -3190,9 +3091,7 @@
 	struct yaffs_dev *dev = obj->my_dev;
 	int x_offs = sizeof(struct yaffs_obj_hdr);
 	int x_size = dev->data_bytes_per_chunk - sizeof(struct yaffs_obj_hdr);
-
 	char *x_buffer;
-
 	int retval = 0;
 
 	if (obj->hdr_chunk < 1)
@@ -3208,7 +3107,7 @@
 			return 0;
 	}
 
-	buffer = (char *)yaffs_get_temp_buffer(dev, __LINE__);
+	buffer = (char *)yaffs_get_temp_buffer(dev);
 	if (!buffer)
 		return -ENOMEM;
 
@@ -3230,7 +3129,7 @@
 		else
 			retval = nval_list(x_buffer, x_size, value, size);
 	}
-	yaffs_release_temp_buffer(dev, (u8 *) buffer, __LINE__);
+	yaffs_release_temp_buffer(dev, (u8 *) buffer);
 	return retval;
 }
 
@@ -3258,44 +3157,38 @@
 
 static void yaffs_check_obj_details_loaded(struct yaffs_obj *in)
 {
-	u8 *chunk_data;
+	u8 *buf;
 	struct yaffs_obj_hdr *oh;
 	struct yaffs_dev *dev;
 	struct yaffs_ext_tags tags;
 	int result;
 	int alloc_failed = 0;
 
-	if (!in)
+	if (!in || !in->lazy_loaded || in->hdr_chunk < 1)
 		return;
 
 	dev = in->my_dev;
+	in->lazy_loaded = 0;
+	buf = yaffs_get_temp_buffer(dev);
 
-	if (in->lazy_loaded && in->hdr_chunk > 0) {
-		in->lazy_loaded = 0;
-		chunk_data = yaffs_get_temp_buffer(dev, __LINE__);
-
-		result =
-		    yaffs_rd_chunk_tags_nand(dev, in->hdr_chunk, chunk_data,
-					     &tags);
-		oh = (struct yaffs_obj_hdr *)chunk_data;
-
-		in->yst_mode = oh->yst_mode;
-		yaffs_load_attribs(in, oh);
-		yaffs_set_obj_name_from_oh(in, oh);
+	result = yaffs_rd_chunk_tags_nand(dev, in->hdr_chunk, buf, &tags);
+	oh = (struct yaffs_obj_hdr *)buf;
 
-		if (in->variant_type == YAFFS_OBJECT_TYPE_SYMLINK) {
-			in->variant.symlink_variant.alias =
-			    yaffs_clone_str(oh->alias);
-			if (!in->variant.symlink_variant.alias)
-				alloc_failed = 1;	/* Not returned to caller */
-		}
+	in->yst_mode = oh->yst_mode;
+	yaffs_load_attribs(in, oh);
+	yaffs_set_obj_name_from_oh(in, oh);
 
-		yaffs_release_temp_buffer(dev, chunk_data, __LINE__);
+	if (in->variant_type == YAFFS_OBJECT_TYPE_SYMLINK) {
+		in->variant.symlink_variant.alias =
+		    yaffs_clone_str(oh->alias);
+		if (!in->variant.symlink_variant.alias)
+			alloc_failed = 1;	/* Not returned */
 	}
+	yaffs_release_temp_buffer(dev, buf);
 }
 
-static void yaffs_load_name_from_oh(struct yaffs_dev *dev, YCHAR * name,
-				    const YCHAR * oh_name, int buff_size)
+static void yaffs_load_name_from_oh(struct yaffs_dev *dev, YCHAR *name,
+				    const YCHAR *oh_name, int buff_size)
 {
 #ifdef CONFIG_YAFFS_AUTO_UNICODE
 	if (dev->param.auto_unicode) {
@@ -3312,17 +3205,18 @@
 			}
 		} else {
 			strncpy(name, oh_name + 1, buff_size - 1);
-                }
+		}
 	} else {
 #else
-        {
+	(void) dev;
+	{
 #endif
 		strncpy(name, oh_name, buff_size - 1);
-        }
+	}
 }
 
-static void yaffs_load_oh_from_name(struct yaffs_dev *dev, YCHAR * oh_name,
-				    const YCHAR * name)
+static void yaffs_load_oh_from_name(struct yaffs_dev *dev, YCHAR *oh_name,
+				    const YCHAR *name)
 {
 #ifdef CONFIG_YAFFS_AUTO_UNICODE
 
@@ -3342,7 +3236,7 @@
 		}
 
 		if (is_ascii) {
-			/* It is an ASCII name, so do a unicode to ascii conversion */
+			/* It is an ASCII name, so convert unicode to ascii */
 			char *ascii_oh_name = (char *)oh_name;
 			int n = YAFFS_MAX_NAME_LENGTH - 1;
 			while (n > 0 && *name) {
@@ -3352,180 +3246,165 @@
 				n--;
 			}
 		} else {
-			/* It is a unicode name, so save starting at the second YCHAR */
+			/* Unicode name, so save starting at the second YCHAR */
 			*oh_name = 0;
-			strncpy(oh_name + 1, name,
-				      YAFFS_MAX_NAME_LENGTH - 2);
+			strncpy(oh_name + 1, name, YAFFS_MAX_NAME_LENGTH - 2);
 		}
 	} else {
 #else
-        {
+	dev = dev;
+	{
 #endif
 		strncpy(oh_name, name, YAFFS_MAX_NAME_LENGTH - 1);
-        }
-
+	}
 }
 
 /* UpdateObjectHeader updates the header on NAND for an object.
  * If name is not NULL, then that new name is used.
  */
-int yaffs_update_oh(struct yaffs_obj *in, const YCHAR * name, int force,
+int yaffs_update_oh(struct yaffs_obj *in, const YCHAR *name, int force,
 		    int is_shrink, int shadows, struct yaffs_xattr_mod *xmod)
 {
 
 	struct yaffs_block_info *bi;
-
 	struct yaffs_dev *dev = in->my_dev;
-
 	int prev_chunk_id;
 	int ret_val = 0;
 	int result = 0;
-
 	int new_chunk_id;
 	struct yaffs_ext_tags new_tags;
 	struct yaffs_ext_tags old_tags;
 	const YCHAR *alias = NULL;
-
 	u8 *buffer = NULL;
 	YCHAR old_name[YAFFS_MAX_NAME_LENGTH + 1];
-
 	struct yaffs_obj_hdr *oh = NULL;
+	loff_t file_size = 0;
 
 	strcpy(old_name, _Y("silly old name"));
 
-	if (!in->fake || in == dev->root_dir ||
-	    force || xmod) {
-
-		yaffs_check_gc(dev, 0);
-		yaffs_check_obj_details_loaded(in);
-
-		buffer = yaffs_get_temp_buffer(in->my_dev, __LINE__);
-		oh = (struct yaffs_obj_hdr *)buffer;
-
-		prev_chunk_id = in->hdr_chunk;
+	if (in->fake && in != dev->root_dir && !force && !xmod)
+		return ret_val;
 
-		if (prev_chunk_id > 0) {
-			result = yaffs_rd_chunk_tags_nand(dev, prev_chunk_id,
-							  buffer, &old_tags);
+	yaffs_check_gc(dev, 0);
+	yaffs_check_obj_details_loaded(in);
 
-			yaffs_verify_oh(in, oh, &old_tags, 0);
+	buffer = yaffs_get_temp_buffer(in->my_dev);
+	oh = (struct yaffs_obj_hdr *)buffer;
 
-			memcpy(old_name, oh->name, sizeof(oh->name));
-			memset(buffer, 0xFF, sizeof(struct yaffs_obj_hdr));
-		} else {
-			memset(buffer, 0xFF, dev->data_bytes_per_chunk);
-                }
+	prev_chunk_id = in->hdr_chunk;
 
-		oh->type = in->variant_type;
-		oh->yst_mode = in->yst_mode;
-		oh->shadows_obj = oh->inband_shadowed_obj_id = shadows;
+	if (prev_chunk_id > 0) {
+		result = yaffs_rd_chunk_tags_nand(dev, prev_chunk_id,
+						  buffer, &old_tags);
 
-		yaffs_load_attribs_oh(oh, in);
+		yaffs_verify_oh(in, oh, &old_tags, 0);
+		memcpy(old_name, oh->name, sizeof(oh->name));
+		memset(buffer, 0xff, sizeof(struct yaffs_obj_hdr));
+	} else {
+		memset(buffer, 0xff, dev->data_bytes_per_chunk);
+	}
 
-		if (in->parent)
-			oh->parent_obj_id = in->parent->obj_id;
-		else
-			oh->parent_obj_id = 0;
+	oh->type = in->variant_type;
+	oh->yst_mode = in->yst_mode;
+	oh->shadows_obj = oh->inband_shadowed_obj_id = shadows;
 
-		if (name && *name) {
-			memset(oh->name, 0, sizeof(oh->name));
-			yaffs_load_oh_from_name(dev, oh->name, name);
-		} else if (prev_chunk_id > 0) {
-			memcpy(oh->name, old_name, sizeof(oh->name));
-		} else {
-			memset(oh->name, 0, sizeof(oh->name));
-                }
+	yaffs_load_attribs_oh(oh, in);
 
-		oh->is_shrink = is_shrink;
+	if (in->parent)
+		oh->parent_obj_id = in->parent->obj_id;
+	else
+		oh->parent_obj_id = 0;
 
-		switch (in->variant_type) {
-		case YAFFS_OBJECT_TYPE_UNKNOWN:
-			/* Should not happen */
-			break;
-		case YAFFS_OBJECT_TYPE_FILE:
-			oh->file_size =
-			    (oh->parent_obj_id == YAFFS_OBJECTID_DELETED
-			     || oh->parent_obj_id ==
-			     YAFFS_OBJECTID_UNLINKED) ? 0 : in->
-			    variant.file_variant.file_size;
-			break;
-		case YAFFS_OBJECT_TYPE_HARDLINK:
-			oh->equiv_id = in->variant.hardlink_variant.equiv_id;
-			break;
-		case YAFFS_OBJECT_TYPE_SPECIAL:
-			/* Do nothing */
-			break;
-		case YAFFS_OBJECT_TYPE_DIRECTORY:
-			/* Do nothing */
-			break;
-		case YAFFS_OBJECT_TYPE_SYMLINK:
-			alias = in->variant.symlink_variant.alias;
-			if (!alias)
-				alias = _Y("no alias");
-			strncpy(oh->alias, alias, YAFFS_MAX_ALIAS_LENGTH);
-			oh->alias[YAFFS_MAX_ALIAS_LENGTH] = 0;
-			break;
-		}
+	if (name && *name) {
+		memset(oh->name, 0, sizeof(oh->name));
+		yaffs_load_oh_from_name(dev, oh->name, name);
+	} else if (prev_chunk_id > 0) {
+		memcpy(oh->name, old_name, sizeof(oh->name));
+	} else {
+		memset(oh->name, 0, sizeof(oh->name));
+	}
 
-		/* process any xattrib modifications */
-		if (xmod)
-			yaffs_apply_xattrib_mod(in, (char *)buffer, xmod);
-
-		/* Tags */
-		yaffs_init_tags(&new_tags);
-		in->serial++;
-		new_tags.chunk_id = 0;
-		new_tags.obj_id = in->obj_id;
-		new_tags.serial_number = in->serial;
-
-		/* Add extra info for file header */
-
-		new_tags.extra_available = 1;
-		new_tags.extra_parent_id = oh->parent_obj_id;
-		new_tags.extra_length = oh->file_size;
-		new_tags.extra_is_shrink = oh->is_shrink;
-		new_tags.extra_equiv_id = oh->equiv_id;
-		new_tags.extra_shadows = (oh->shadows_obj > 0) ? 1 : 0;
-		new_tags.extra_obj_type = in->variant_type;
-
-		yaffs_verify_oh(in, oh, &new_tags, 1);
-
-		/* Create new chunk in NAND */
-		new_chunk_id =
-		    yaffs_write_new_chunk(dev, buffer, &new_tags,
-					  (prev_chunk_id > 0) ? 1 : 0);
+	oh->is_shrink = is_shrink;
 
-		if (new_chunk_id >= 0) {
+	switch (in->variant_type) {
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		/* Should not happen */
+		break;
+	case YAFFS_OBJECT_TYPE_FILE:
+		if (oh->parent_obj_id != YAFFS_OBJECTID_DELETED &&
+		    oh->parent_obj_id != YAFFS_OBJECTID_UNLINKED)
+			file_size = in->variant.file_variant.file_size;
+		yaffs_oh_size_load(oh, file_size);
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		oh->equiv_id = in->variant.hardlink_variant.equiv_id;
+		break;
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		/* Do nothing */
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		/* Do nothing */
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		alias = in->variant.symlink_variant.alias;
+		if (!alias)
+			alias = _Y("no alias");
+		strncpy(oh->alias, alias, YAFFS_MAX_ALIAS_LENGTH);
+		oh->alias[YAFFS_MAX_ALIAS_LENGTH] = 0;
+		break;
+	}
 
-			in->hdr_chunk = new_chunk_id;
+	/* process any xattrib modifications */
+	if (xmod)
+		yaffs_apply_xattrib_mod(in, (char *)buffer, xmod);
+
+	/* Tags */
+	memset(&new_tags, 0, sizeof(new_tags));
+	in->serial++;
+	new_tags.chunk_id = 0;
+	new_tags.obj_id = in->obj_id;
+	new_tags.serial_number = in->serial;
 
-			if (prev_chunk_id > 0) {
-				yaffs_chunk_del(dev, prev_chunk_id, 1,
-						__LINE__);
-			}
+	/* Add extra info for file header */
+	new_tags.extra_available = 1;
+	new_tags.extra_parent_id = oh->parent_obj_id;
+	new_tags.extra_file_size = file_size;
+	new_tags.extra_is_shrink = oh->is_shrink;
+	new_tags.extra_equiv_id = oh->equiv_id;
+	new_tags.extra_shadows = (oh->shadows_obj > 0) ? 1 : 0;
+	new_tags.extra_obj_type = in->variant_type;
+	yaffs_verify_oh(in, oh, &new_tags, 1);
 
-			if (!yaffs_obj_cache_dirty(in))
-				in->dirty = 0;
+	/* Create new chunk in NAND */
+	new_chunk_id =
+	    yaffs_write_new_chunk(dev, buffer, &new_tags,
+				  (prev_chunk_id > 0) ? 1 : 0);
 
-			/* If this was a shrink, then mark the block that the chunk lives on */
-			if (is_shrink) {
-				bi = yaffs_get_block_info(in->my_dev,
-							  new_chunk_id /
-							  in->my_dev->param.
-							  chunks_per_block);
-				bi->has_shrink_hdr = 1;
-			}
+	if (buffer)
+		yaffs_release_temp_buffer(dev, buffer);
 
-		}
+	if (new_chunk_id < 0)
+		return new_chunk_id;
 
-		ret_val = new_chunk_id;
+	in->hdr_chunk = new_chunk_id;
 
+	if (prev_chunk_id > 0)
+		yaffs_chunk_del(dev, prev_chunk_id, 1, __LINE__);
+
+	if (!yaffs_obj_cache_dirty(in))
+		in->dirty = 0;
+
+	/* If this was a shrink, then mark the block
+	 * that the chunk lives on */
+	if (is_shrink) {
+		bi = yaffs_get_block_info(in->my_dev,
+					  new_chunk_id /
+					  in->my_dev->param.chunks_per_block);
+		bi->has_shrink_hdr = 1;
 	}
 
-	if (buffer)
-		yaffs_release_temp_buffer(dev, buffer, __LINE__);
 
-	return ret_val;
+	return new_chunk_id;
 }
 
 /*--------------------- File read/write ------------------------
@@ -3540,21 +3419,17 @@
 
 int yaffs_file_rd(struct yaffs_obj *in, u8 * buffer, loff_t offset, int n_bytes)
 {
-
 	int chunk;
 	u32 start;
 	int n_copy;
 	int n = n_bytes;
 	int n_done = 0;
 	struct yaffs_cache *cache;
-
 	struct yaffs_dev *dev;
 
 	dev = in->my_dev;
 
 	while (n > 0) {
-		/* chunk = offset / dev->data_bytes_per_chunk + 1; */
-		/* start = offset % dev->data_bytes_per_chunk; */
 		yaffs_addr_to_chunk(dev, offset, &chunk, &start);
 		chunk++;
 
@@ -3568,15 +3443,16 @@
 
 		cache = yaffs_find_chunk_cache(in, chunk);
 
-		/* If the chunk is already in the cache or it is less than a whole chunk
-		 * or we're using inband tags then use the cache (if there is caching)
-		 * else bypass the cache.
+		/* If the chunk is already in the cache or it is less than
+		 * a whole chunk or we're using inband tags then use the cache
+		 * (if there is caching) else bypass the cache.
 		 */
-		if (cache || n_copy != dev->data_bytes_per_chunk
-		    || dev->param.inband_tags) {
+		if (cache || n_copy != dev->data_bytes_per_chunk ||
+		    dev->param.inband_tags) {
 			if (dev->param.n_caches > 0) {
 
-				/* If we can't find the data in the cache, then load it up. */
+				/* If we can't find the data in the cache,
+				 * then load it up. */
 
 				if (!cache) {
 					cache =
@@ -3601,34 +3477,27 @@
 				/* Read into the local buffer then copy.. */
 
 				u8 *local_buffer =
-				    yaffs_get_temp_buffer(dev, __LINE__);
+				    yaffs_get_temp_buffer(dev);
 				yaffs_rd_data_obj(in, chunk, local_buffer);
 
 				memcpy(buffer, &local_buffer[start], n_copy);
 
-				yaffs_release_temp_buffer(dev, local_buffer,
-							  __LINE__);
+				yaffs_release_temp_buffer(dev, local_buffer);
 			}
-
 		} else {
-
-			/* A full chunk. Read directly into the supplied buffer. */
+			/* A full chunk. Read directly into the buffer. */
 			yaffs_rd_data_obj(in, chunk, buffer);
-
 		}
-
 		n -= n_copy;
 		offset += n_copy;
 		buffer += n_copy;
 		n_done += n_copy;
-
 	}
-
 	return n_done;
 }
 
-int yaffs_do_file_wr(struct yaffs_obj *in, const u8 * buffer, loff_t offset,
-		     int n_bytes, int write_trhrough)
+int yaffs_do_file_wr(struct yaffs_obj *in, const u8 *buffer, loff_t offset,
+		     int n_bytes, int write_through)
 {
 
 	int chunk;
@@ -3637,11 +3506,10 @@
 	int n = n_bytes;
 	int n_done = 0;
 	int n_writeback;
-	int start_write = offset;
+	loff_t start_write = offset;
 	int chunk_written = 0;
 	u32 n_bytes_read;
-	u32 chunk_start;
-
+	loff_t chunk_start;
 	struct yaffs_dev *dev;
 
 	dev = in->my_dev;
@@ -3649,11 +3517,12 @@
 	while (n > 0 && chunk_written >= 0) {
 		yaffs_addr_to_chunk(dev, offset, &chunk, &start);
 
-		if (chunk * dev->data_bytes_per_chunk + start != offset ||
+		if (((loff_t)chunk) *
+		    dev->data_bytes_per_chunk + start != offset ||
 		    start >= dev->data_bytes_per_chunk) {
 			yaffs_trace(YAFFS_TRACE_ERROR,
-				"AddrToChunk of offset %d gives chunk %d start %d",
-				(int)offset, chunk, start);
+				"AddrToChunk of offset %lld gives chunk %d start %d",
+				offset, chunk, start);
 		}
 		chunk++;	/* File pos to chunk in file offset */
 
@@ -3664,12 +3533,14 @@
 		if ((start + n) < dev->data_bytes_per_chunk) {
 			n_copy = n;
 
-			/* Now folks, to calculate how many bytes to write back....
-			 * If we're overwriting and not writing to then end of file then
-			 * we need to write back as much as was there before.
+			/* Now calculate how many bytes to write back....
+			 * If we're overwriting and not writing to then end of
+			 * file then we need to write back as much as was there
+			 * before.
 			 */
 
-			chunk_start = ((chunk - 1) * dev->data_bytes_per_chunk);
+			chunk_start = (((loff_t)(chunk - 1)) *
+					dev->data_bytes_per_chunk);
 
 			if (chunk_start > in->variant.file_variant.file_size)
 				n_bytes_read = 0;	/* Past end of file */
@@ -3685,27 +3556,30 @@
 			    (n_bytes_read >
 			     (start + n)) ? n_bytes_read : (start + n);
 
-			if (n_writeback < 0
-			    || n_writeback > dev->data_bytes_per_chunk)
-				YBUG();
+			if (n_writeback < 0 ||
+			    n_writeback > dev->data_bytes_per_chunk)
+				BUG();
 
 		} else {
 			n_copy = dev->data_bytes_per_chunk - start;
 			n_writeback = dev->data_bytes_per_chunk;
 		}
 
-		if (n_copy != dev->data_bytes_per_chunk
-		    || dev->param.inband_tags) {
-			/* An incomplete start or end chunk (or maybe both start and end chunk),
-			 * or we're using inband tags, so we want to use the cache buffers.
+		if (n_copy != dev->data_bytes_per_chunk ||
+		    dev->param.inband_tags) {
+			/* An incomplete start or end chunk (or maybe both
+			 * start and end chunk), or we're using inband tags,
+			 * so we want to use the cache buffers.
 			 */
 			if (dev->param.n_caches > 0) {
 				struct yaffs_cache *cache;
-				/* If we can't find the data in the cache, then load the cache */
+
+				/* If we can't find the data in the cache, then
+				 * load the cache */
 				cache = yaffs_find_chunk_cache(in, chunk);
 
-				if (!cache
-				    && yaffs_check_alloc_available(dev, 1)) {
+				if (!cache &&
+				    yaffs_check_alloc_available(dev, 1)) {
 					cache = yaffs_grab_chunk_cache(dev);
 					cache->object = in;
 					cache->chunk_id = chunk;
@@ -3717,8 +3591,9 @@
 					   !cache->dirty &&
 					   !yaffs_check_alloc_available(dev,
 									1)) {
-					/* Drop the cache if it was a read cache item and
-					 * no space check has been made for it.
+					/* Drop the cache if it was a read cache
+					 * item and no space check has been made
+					 * for it.
 					 */
 					cache = NULL;
 				}
@@ -3733,7 +3608,7 @@
 					cache->locked = 0;
 					cache->n_bytes = n_writeback;
 
-					if (write_trhrough) {
+					if (write_through) {
 						chunk_written =
 						    yaffs_wr_data_obj
 						    (cache->object,
@@ -3742,20 +3617,18 @@
 						     cache->n_bytes, 1);
 						cache->dirty = 0;
 					}
-
 				} else {
-					chunk_written = -1;	/* fail the write */
+					chunk_written = -1;	/* fail write */
 				}
 			} else {
-				/* An incomplete start or end chunk (or maybe both start and end chunk)
-				 * Read into the local buffer then copy, then copy over and write back.
+				/* An incomplete start or end chunk (or maybe
+				 * both start and end chunk). Read into the
+				 * local buffer then copy over and write back.
 				 */
 
-				u8 *local_buffer =
-				    yaffs_get_temp_buffer(dev, __LINE__);
+				u8 *local_buffer = yaffs_get_temp_buffer(dev);
 
 				yaffs_rd_data_obj(in, chunk, local_buffer);
-
 				memcpy(&local_buffer[start], buffer, n_copy);
 
 				chunk_written =
